/*  ---------------------------------------------------------------------------------------
    TFG - Emissió i Validació de bitllets amb RFID
    Andreu Fernández Loma
    TEST  de Arduino UNO + SHIELD ETHERNET + RFID RD522
    
    El programa imprimeis la IP i un TOKEN (que no es mes que el nº de tarja RFID)
-------------------------------------------------------------------------------------------
*/

/* ------------------------------ Llibreries necessaries ----------------------------------
 SPI.h és un bus de comunicació entre dispositius i te una arquitectura mestre-esclau 

 Wire.h és la llibreria per connectar dispositius pel bus I2C
  MASTER - NODEMCU  D1 i D2
  SLAVE - ARDUINO UNO D1 i D2

 MFRC522 i RFID son les llibreries pròpies que gestionen RFID
 -------------------------------------------------------------------------------------------
 */ 

#include <SPI.h>
#include <ESP8266WiFi.h> //Incluye la libreria ESP8266WiFi
#include <SoftwareSerial.h>
//#include <Wire.h>


/* ------------------------------ Llibreries necessaries ----------------------------------
Dades d'acces a la xarxa wifi
*/

const char* ssid = "Ander_wir";             //Indicamos el nombre de la red WiFi (SSID) a la que queremos conectarnos.
const char* password = "1111AAAA";          //Indicamos la contraseÃ±a de la red WiFi
const char* host = "eimtcms.uoc.edu";       //Declaramos el servidor de conexiÃ³n

/* Constans dels leds  - 
LEDVERDE = Bitllet autoritzat
LedRojo = Bitllet no autoritzat
*/
const int ledVERDE = D6;
const int ledROJO = D7;

/*
 SoftwareSerial(rxPIN, txPIN)
 */
 
SoftwareSerial NodeSerial(D2,D3);
String inString = "";

// variables controla led
boolean encontrado;
int contador = 0;


void setup ()
{
  pinMode(D2, INPUT);
  pinMode(D3,OUTPUT);
  Serial.begin(115200);                         //Inicializamos el Puerto Serie
  NodeSerial.begin(4800);
  
  Serial.println();
  Serial.printf("Connecting to %s ", ssid);     //Inicializamos la conexion Wi-Fi en modo Station
  WiFi.begin(ssid, password);
  Serial.println(" connected");
  Serial.begin(9600);

 // Inicialitza els led
  pinMode(ledVERDE, OUTPUT);
  pinMode(ledROJO, OUTPUT);
}

void loop() {

contador = 0;
encontrado=true;
while (Serial.available() > 0) {
 //int valor = NodeSerial.parseInt();
}

// a valor queda el caracter que ha rebut el pin RX del port serie
int valor = NodeSerial.read();
if (isDigit(valor)) {
    inString += (char)valor;
 }

 /*
  * El codi \n és el ASCII 10 o salt de linea
  * Quant el detecta llavors crida la connexií Wifi
  */
 
 if (valor == '\n') {
    conectaWIFI(inString);
    inString= "";
  }
   
}

/*
 * Funció a la que li paso com a parametre(tokenpasado)
 * el nº de tarja a consultar en el servidor 
 */
void conectaWIFI(String tokenpasado) {
contador=0;
Serial.print("Connectant a : ");
Serial.println(host);
 // Crea una clase WiFiClient per crear una connexió TCP 
 WiFiClient client;
 const int httpPort = 80;
 if (!client.connect(host, httpPort)) {
  Serial.println("Errada de conexió");
  return;
 }
 
 /*
  * Creo la URL php de sol.licitut de dades
  */
 
 String url = "/~afernandezlom/indexTFG_1.php";
 String dato1 = "?tarjeta=TOKEN";
 String dato2 = tokenpasado;
 String dato3 = "TOKEN" + dato2;
 Serial.println ("TARJETA A BUSCAR EN HOST : " + dato3);
 client.print(String("GET ") + url + dato1 + dato2 + " HTTP/1.1\r\n" +
 "Host: " + host + "\r\n" +
 "Connection: close\r\n\r\n");
 unsigned long timeout = millis();

while (client.available() == 0) {
  if (millis() - timeout > 5000) {
  Serial.println(">>> Client Timeout !");
  client.stop();
  return;
  }
 }
 
 //si existe información pendiente
while (client.available()) {
  //contador =0;
  String line = client.readStringUntil('\n');
  //Serial.println("line = " + line);
  contador ++;
  //Serial.print("contador : " );
 // Serial.println(contador);
  encender();
  if (line.substring(line.indexOf('T'),line.indexOf('T')+23) == dato3) {
    Serial.println(line.substring(line.indexOf(dato3)+23,line.length()));
    contador++;
    encontrado = true;
    //encender();
  }
//if ((contador == 7) && (encontrado=false)) {Serial.println(" NO ENCONTRADO");};
/*if ((contador = 11) && (encontrado = false)) {
    digitalWrite(ledROJO, HIGH);
    delay(1000);
    digitalWrite(ledROJO, LOW);
    encontrado = false;
    contador=0;
    }
*/
}


 
client.stop();
}



 
void encender () {
  
  while (contador<8){
  Serial.println("*********    NO LOCALIZADO    *********");
  digitalWrite(ledROJO,HIGH);
  delay(300);
  digitalWrite(ledROJO, LOW);
  return;
  }
  
  while (contador>8) {
  digitalWrite(ledVERDE,HIGH);
  delay(1000);
  digitalWrite(ledVERDE, LOW);
  delay(1000);
  contador=0;
  Serial.println(" *******   LOCALIZADO   *********");
  return;
  }
  return;
  }



